"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const jsxRuntime = require("../../jsx-runtime-ec586afa.cjs");
const require$$0 = require("react");
const reactBootstrap = require("react-bootstrap");
function FormWrapper(props) {
  const [Validated, setValidated] = require$$0.useState(false);
  const [ButtonDisabled, setButtonDisabled] = require$$0.useState(false);
  const [Error, setError] = require$$0.useState(void 0);
  const [Success, setSuccess] = require$$0.useState(false);
  require$$0.useEffect(() => {
    if (props.setButtonDisabled)
      props.setButtonDisabled(ButtonDisabled);
  }, [ButtonDisabled]);
  async function onSubmit(e) {
    e.preventDefault();
    setButtonDisabled(true);
    setError(void 0);
    if (!e.currentTarget.checkValidity()) {
      setValidated(true);
      setButtonDisabled(false);
      return;
    }
    setValidated(false);
    const response = await props.onSubmit(e);
    if (response.error)
      setError({ ...response.error });
    if (!response.error) {
      setSuccess(true);
      setTimeout(() => {
        setSuccess(false);
      }, 5e3);
    }
    if (response.payloads && props.success)
      props.success(response.payloads);
    setButtonDisabled(false);
  }
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(reactBootstrap.Form, { noValidate: true, validated: Validated, onSubmit, children: [
    Error && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(reactBootstrap.Alert, { variant: "warning", children: [
      /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(reactBootstrap.Alert.Heading, { children: [
        Error.abstract && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs("span", { children: [
          "[",
          Error.abstract,
          "]"
        ] }),
        Error.title && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("span", { children: Error.title })
      ] }),
      Error.messages && props.ErrorMessages ? /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(props.ErrorMessages, { messages: Error.messages }) : /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(ErrorMessages, { messages: ErrorMessages })
    ] }),
    Success && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Alert, { variant: "success", children: props.successMessage || "処理に成功しました" }),
    props.children
  ] });
}
function ErrorMessages(props) {
  if (Array.isArray(props.messages))
    return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("ul", { children: props.messages.map(
      (message, idx) => /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(ErrorMessages, { messages: message }, `errorMessageArray-${idx}`)
    ) });
  if (typeof props.messages === "string" || props.messages instanceof String)
    return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("li", { children: props.messages });
  if (props.messages !== null && typeof props.messages === "object")
    return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(jsxRuntime.jsxRuntimeExports.Fragment, { children: Object.keys(props.messages).map(
      (key, idx) => /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(ErrorMessages, { messages: props.messages[key] }, `errorMessageObject-${idx}`)
    ) });
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(jsxRuntime.jsxRuntimeExports.Fragment, {});
}
function InputWrapper(props) {
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs("div", { className: "mb-2", children: [
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(reactBootstrap.Form.Label, { children: [
      props.label,
      props.required && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("span", { className: "text-danger", children: "＊" })
    ] }),
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("div", { className: "ms-2", children: props.children })
  ] });
}
exports.ErrorMessages = ErrorMessages;
exports.FormWrapper = FormWrapper;
exports.InputWrapper = InputWrapper;
