"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const jsxRuntime = require("../jsx-runtime-ec586afa.cjs");
const require$$0 = require("react");
const reactBootstrap = require("react-bootstrap");
function Anchor(props) {
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(
    "a",
    {
      ...props,
      className: (props.as === "button" ? `btn btn-${props.variant || "primary"} ` : "") + (props.className || "")
    }
  );
}
function Paginate(props) {
  function toPrev() {
    props.setPage(Math.max(props.meta.currentPage, 1));
  }
  function toNext() {
    props.setPage(Math.min(props.meta.lastPage, props.meta.currentPage + 1));
  }
  function toFirst() {
    props.setPage(1);
  }
  function toLast() {
    props.setPage(props.meta.lastPage);
  }
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(reactBootstrap.Pagination, { children: [
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Pagination.First, { onClick: toFirst, disabled: props.meta.currentPage === 1 }),
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Pagination.Prev, { onClick: toPrev, disabled: props.meta.currentPage === 1 }),
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Pagination.Item, { disabled: true, children: props.meta.currentPage }),
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Pagination.Next, { onClick: toNext, disabled: props.meta.lastPage === props.meta.currentPage }),
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Pagination.Last, { onCanPlay: toLast, disabled: props.meta.currentPage === props.meta.lastPage })
  ] });
}
function ListView(props) {
  const [Page, setPage] = require$$0.useState(1);
  const [Payloads, setPayloads] = require$$0.useState();
  require$$0.useEffect(() => {
    getItems();
  }, [Page, props.reload]);
  async function getItems() {
    const payloads = await props.getItems({ page: Page });
    if (!payloads)
      return;
    setPayloads({ ...{}, ...payloads });
  }
  if (!Payloads)
    return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(jsxRuntime.jsxRuntimeExports.Fragment, {});
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(jsxRuntime.jsxRuntimeExports.Fragment, { children: [
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs("div", { className: "mb-2", children: [
      Payloads.meta.length,
      "件中",
      Payloads.meta.getLength,
      "件表示中"
    ] }),
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(props.itemWrapper, { children: Payloads.items.map(props.itemCallback) }),
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("div", { className: "mt-2", children: /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(Paginate, { meta: Payloads.meta, setPage }) })
  ] });
}
function PageWrapper(props) {
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs("div", { children: [
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx("h3", { children: props.title }),
    props.breadCrumb && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(reactBootstrap.Breadcrumb, { className: "my-2", children: [
      /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Breadcrumb.Item, { href: "/", children: "HOME" }),
      props.breadCrumb.map(
        (item) => /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(BreadcrumbItem, { item, onClick: props.breadCrumbOnClick }, item.text)
      ),
      /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Breadcrumb.Item, { active: true, children: props.title })
    ] }),
    props.children
  ] });
}
function BreadcrumbItem(props) {
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Breadcrumb.Item, { href: props.item.link, onClick: props.onClick, children: props.item.text });
}
function Popup({ header, footer, children, ...props }) {
  return /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsxs(reactBootstrap.Modal, { animation: true, scrollable: true, centered: true, ...props, children: [
    header && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Modal.Header, { closeButton: true, children: header }),
    /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Modal.Body, { children }),
    footer && /* @__PURE__ */ jsxRuntime.jsxRuntimeExports.jsx(reactBootstrap.Modal.Footer, { children: footer })
  ] });
}
exports.Anchor = Anchor;
exports.ListView = ListView;
exports.PageWrapper = PageWrapper;
exports.Paginate = Paginate;
exports.Popup = Popup;
